-- macro:
-- #showtooltip
-- /run ShamanMount:M(GetRunningMacro(),"ground_mount_name","flying_mount_name")
-- /click ShamanMount

ShamanMountData = {["MacroName"]=nil,["GroundMountName"]=nil,["FlyingMountName"]=nil}
local GhostWolf,WaterWalking,AbyssalSeahorse,SubduedSeaHorse,SeaTurtle,AzureWaterStrider=(GetSpellInfo(2645)),(GetSpellInfo(546)),(GetSpellInfo(75207)),(GetSpellInfo(98718)),(GetSpellInfo(64731)),(GetSpellInfo(118089))
local WalterWalkingMacro = "/cast [@player]"..WaterWalking.."\n"
local time=GetTime()
local f=CreateFrame("Button","ShamanMount",nil,"SecureActionButtonTemplate")
local MN,GMN,FMN

function f:M(MN,GMN,FMN)
  local _,Class,InstanceType
  _,Class=UnitClass("player")
  _,InstanceType=IsInInstance()
  ShamanMountData["MacroName"]=GetMacroInfo(MN)
  ShamanMountData["GroundMountName"]=GMN
  ShamanMountData["FlyingMountName"]=FMN
  if not ShamanMountData["FlyingMountName"] then ShamanMountData["FlyingMountName"]=ShamanMountData["GroundMountName"] end
  if not InCombatLockdown() then
    self:SetAttribute("type","macro")
    if CanExitVehicle() then
      self:SetAttribute("macrotext","/run VehicleExit()")
    elseif IsMounted() then
      self:SetAttribute("macrotext","/dismount [noflying]")
    elseif IsSubmerged() and GetTime()-time<1.0 and IsUsableSpell(ShamanMountData["FlyingMountName"]) and GetUnitSpeed("player")==0 then
      self:SetAttribute("macrotext",WalterWalkingMacro.."/cast "..ShamanMountData["FlyingMountName"])
    elseif IsSubmerged() and GetTime()-time<1.0 and IsUsableSpell(AzureWaterStrider) and InstanceType~="pvp" and GetUnitSpeed("player")==0 and Class~="SHAMAN" then
      self:SetAttribute("macrotext","/cast "..AzureWaterStrider)
    elseif strsub(GetMapInfo(),0,7)=="Vashjir" and IsUsableSpell(AbyssalSeahorse) and GetUnitSpeed("player")==0 then
      self:SetAttribute("macrotext",WalterWalkingMacro.."/cast "..AbyssalSeahorse)
    elseif IsUsableSpell(SubduedSeahorse) and GetUnitSpeed("player")==0 then
      self:SetAttribute("macrotext",WalterWalkingMacro.."/cast "..SubduedSeahorse)
    elseif IsUsableSpell(SeaTurtle) and GetUnitSpeed("player")==0 then
      self:SetAttribute("macrotext",WalterWalkingMacro.."/cast "..SeaTurtle)
    elseif IsUsableSpell(ShamanMountData["FlyingMountName"]) and IsSwimming() and GetUnitSpeed("player")==0 then
      self:SetAttribute("macrotext",WalterWalkingMacro.."/cast "..ShamanMountData["FlyingMountName"])
    elseif IsUsableSpell(ShamanMountData["FlyingMountName"]) and GetUnitSpeed("player")==0 then
      self:SetAttribute("macrotext","/cast "..ShamanMountData["FlyingMountName"])
    elseif IsUsableSpell(ShamanMountData["GroundMountName"]) and GetUnitSpeed("player")==0 then
      self:SetAttribute("macrotext",WalterWalkingMacro.."/cast "..ShamanMountData["GroundMountName"])
    else
      self:SetAttribute("macrotext","/cast "..GhostWolf)
    end
  end
end

f:SetScript("OnEvent",function(self,event)
  local _,Class=UnitClass("player")
  if event=="PLAYER_REGEN_DISABLED" then
    self:SetAttribute("type","macro")
    self:SetAttribute("macrotext","/run if CanExitVehicle() then VehicleExit() end\n/cast [nomounted]"..GhostWolf.."\n/dismount [noflying]")
  end
  if event=="SPELL_UPDATE_USABLE" and not IsSubmerged() then
    time=GetTime()
  end
  if strsub(GetMapInfo()~=nil and GetMapInfo() or "",0,7)=="Vashjir" and IsSubmerged() and (IsUsableSpell(AbyssalSeahorse) or Class~="SHAMAN" and GetSpellInfo(AbyssalSeahorse)) then
    SetMacroSpell(ShamanMountData["MacroName"],AbyssalSeahorse)
  elseif IsSubmerged() and (IsUsableSpell(SubduedSeahorse) or Class~="SHAMAN" and GetSpellInfo(SubduedSeahorse)) then
    SetMacroSpell(ShamanMountData["MacroName"],SubduedSeahorse)
  elseif IsSubmerged() and (IsUsableSpell(SeaTurtle) or Class~="SHAMAN" and GetSpellInfo(SeaTurtle)) then
    SetMacroSpell(ShamanMountData["MacroName"],SeaTurtle)
  elseif IsUsableSpell(ShamanMountData["FlyingMountName"]) or Class~="SHAMAN" and IsFlyableArea() and GetSpellInfo(ShamanMountData["FlyingMountName"]) then
    SetMacroSpell(ShamanMountData["MacroName"],ShamanMountData["FlyingMountName"])
  elseif IsUsableSpell(ShamanMountData["GroundMountName"]) or Class~="SHAMAN" and GetSpellInfo(ShamanMountData["GroundMountName"]) then
    SetMacroSpell(ShamanMountData["MacroName"],ShamanMountData["GroundMountName"])
  elseif Class=="SHAMAN" then
    SetMacroSpell(ShamanMountData["MacroName"],GhostWolf)
  end
end)

f:RegisterEvent("PLAYER_REGEN_DISABLED")
f:RegisterEvent("SPELL_UPDATE_USABLE")
f:RegisterEvent("ACTIONBAR_SLOT_CHANGED")
f:RegisterEvent("PLAYER_LOGIN")